# Blender GPT Add-on

<p align="center">
<a href="https://www.buymeacoffee.com/ryvn"><img src="https://img.buymeacoffee.com/button-api/?text=Buy me a book&emoji=📚&slug=ryvn&button_colour=40DCA5&font_colour=ffffff&font_family=Bree&outline_colour=000000&coffee_colour=FFDD00" /></a>
</p>

Introducing our newly developed Blender Add-on that harnesses the potential of OpenAI's latest GPT-4 (and GPT-3.5) to transform simple prompts into remarkable 3D models and animations. No more hassle of manually modeling complex 3D elements, let AI do the work!

### Key Features

- **Multi-Lingual Support:** Our user-friendly interface is not confined to a single language. Choose from English, Simplified Chinese, or Traditional Chinese for a comfortable and personalized user experience. Also, you can speak to your software in the language you're comfortable with!
- **Choose Your Model:** Take control of the AI you're working with. Our Add-on allows you to toggle between Chat GPT-3.5 and Chat GPT-4 models based on your preference or task complexity, surely, your accessibility and budget 💰.
- **Adjustable Creativity:** Enjoy flexibility in design with adjustable "creativity" settings. This allows you to control the randomness and creativity of the AI, offering results ranging from highly deterministic (0) to wildly creative (1). Having said that, 0 is recommended.
- **UI Features:** Our user-friendly interface lets you maintain chat history, delete them at will, view produced codes, and much more. Experience the verisimilar simplicity and convenience of OpenAI chat GPT within the comfort of your Blender workspace.
- **Speed and Robustness:** We take pride in our add-on's performance. Experience faster inference times compared to similar products, and witness more robust results, ensuring your creativity is never hindered.

## Get Started

Install our Add-on and dive into the limitless realm of AI-powered 3D modeling.

### Prerequisites

Before you begin, ensure you have the following:

- Blender 3.5 or later installed on your system.
- An OpenAI API key. You can obtain one from the OpenAI website. <a href="https://platform.openai.com/account/api-keys">CLICK ME</a>.

### Installation

To install the Blender GPT, follow the steps below:

1. **Download the Add-on**

   On the GitHub page for the Blender GPT, click on `Code`, then select `Download ZIP`. This will download a ZIP file of the repository to your computer.

2. **Install the Add-on in Blender**

   - Launch Blender.
   - Navigate to `Edit > Preferences > Add-ons > Install`.
   - Locate and select the downloaded ZIP file.
   - Click `Install Add-on`.

3. **Enable the Add-on**

   After installation, enable the add-on by checking the checkbox next to `Blender GPT` (Object).

4. **Enter your OpenAI API Key**

   Go to the Addon preferences menu and paste your OpenAI API key. 


### Usage

Follow the steps below to make the most out of the Blender GPT:

1. **Open the Sidebar in 3D View**

    In the 3D View, press `N` to open the sidebar. You will find the `Blender GPT` tab here.

2. **Select Your Preferred Language**

    You can choose the language of your user interface and prompt input in the Language tab. The options allow for a more user-friendly experience.

3. **Choose the Chat-GPT Model**

    You have the option to select between the gpt-3 (i.e., gpt-3.5) or gpt-4 models in the `chat-gpt model` tab. However, please note that the gpt-4 model can only be selected if you have access to gpt-4 on OpenAI.

4. **Adjust Level of Model Creativity**

    There is a 'creativity' tab that allows you to control the creativity level (from 0 to 1) of the generated results by GPT. By adjusting this setting, you can encourage more novel output by setting a higher value.

5. **Enter Prompt in Input Field**

    Type your commands in plain language, either in English or Chinese, in the input field, e.g., "create 500 cubes in random locations".

6. **Submit Command**

    Click on the `Submit prompt` button. This action will generate and execute the Blender Python code based on your provided prompt.

7. **Review Generated Codes**

    By clicking on the text icon next to `GPT>`, you can view the Python code generated by the chatgpt model. If you're familiar with script writing, you can further edit this Python code for finer control. In case the generated code is of subpar quality, you can tweak it directly and rerun the execution.

8. **Deletion Options**

    There are two ways to delete dialogues. The first is to delete the result of the last conversation. In this case, the `Submit prompt` will change to `Regenerate Response` for a fresh output. The second method allows for deleting all dialogue history. This is useful if you prefer that future generated results are not partially based on previous dialogues.

That's it! Now you can enjoy the convenience of the Blender GPT. Remember, Blender GPT requires an active internet connection to function properly, as it relies on OpenAI's cloud services.
